﻿Public Class Making
    Dim UnyoNum(6) As Integer
    Dim Joutai(3, 3) As CellStatus
    Dim MyGrid As ReverseGrid
    Dim statuses(3, 2) As CellStatus
    Dim houkous(3, 2) As Houkou
    Dim plusX(3, 2), plusY(3, 2) As Integer
    Dim flag As Boolean

    Public Sub New(ByVal g As ReverseGrid)
        MyGrid = g
        statuses(0, 0) = CellStatus.UpDown
        statuses(0, 1) = CellStatus.LeftUp
        statuses(0, 2) = CellStatus.RightUp
        statuses(1, 0) = CellStatus.UpDown
        statuses(1, 1) = CellStatus.LeftDown
        statuses(1, 2) = CellStatus.RightDown
        statuses(2, 0) = CellStatus.LeftRight
        statuses(2, 1) = CellStatus.LeftUp
        statuses(2, 2) = CellStatus.LeftDown
        statuses(3, 0) = CellStatus.LeftRight
        statuses(3, 1) = CellStatus.RightUp
        statuses(3, 2) = CellStatus.RightDown
        houkous(0, 0) = Houkou.Up
        houkous(0, 1) = Houkou.Right
        houkous(0, 2) = Houkou.Left
        houkous(1, 0) = Houkou.Down
        houkous(1, 1) = Houkou.Right
        houkous(1, 2) = Houkou.Left
        houkous(2, 0) = Houkou.Left
        houkous(2, 1) = Houkou.Down
        houkous(2, 2) = Houkou.Up
        houkous(3, 0) = Houkou.Right
        houkous(3, 1) = Houkou.Down
        houkous(3, 2) = Houkou.Up
        plusX(0, 0) = 0
        plusX(0, 1) = -1
        plusX(0, 2) = 1
        plusX(1, 0) = 0
        plusX(1, 1) = -1
        plusX(1, 2) = 1
        plusX(2, 0) = 1
        plusX(2, 1) = 0
        plusX(2, 2) = 0
        plusX(3, 0) = -1
        plusX(3, 1) = 0
        plusX(3, 2) = 0
        plusY(0, 0) = 1
        plusY(0, 1) = 0
        plusY(0, 2) = 0
        plusY(1, 0) = -1
        plusY(1, 1) = 0
        plusY(1, 2) = 0
        plusY(2, 0) = 0
        plusY(2, 1) = -1
        plusY(2, 2) = 1
        plusY(3, 0) = 0
        plusY(3, 1) = -1
        plusY(3, 2) = 1
    End Sub

    Public Sub DoNothing()
        Dim kx, ky As Integer

        For ky = 0 To 3
            For kx = 0 To 3
                Joutai(kx, ky) = CellStatus.Nothing
            Next
        Next
    End Sub

    Public Sub Execution()
        Dim k As Integer

        For k = 0 To 6
            UnyoNum(k) = 0
        Next
        DoNothing()
        flag = True
        Decision(Houkou.Up, 0, 0)
    End Sub

    Private Sub Decision(ByVal hoko As Houkou, ByVal xp As Integer, ByVal yp As Integer)
        Dim k, sum, rndk(2) As Integer

        If xp < 0 Or xp > 3 Or yp < 0 Or yp > 3 Then
            If yp = 4 And xp = 3 Then
                sum = 0
                For k = 1 To 6
                    sum += UnyoNum(k)
                Next
                If sum = 15 Then
                    ShowMaked()
                    flag = False
                End If
            End If
            Exit Sub
        End If
        If Joutai(xp, yp) = CellStatus.Nothing Then
            rndk(0) = RandomN(0, 2)
            rndk(1) = (rndk(0) + RandomN(1, 2)) Mod 3
            rndk(2) = 3 - (rndk(0) + rndk(1))
            Select Case hoko
                Case Houkou.Up
                    subDecision(0, rndk(0), xp, yp)
                    subDecision(0, rndk(1), xp, yp)
                    subDecision(0, rndk(2), xp, yp)
                Case Houkou.Down
                    subDecision(1, rndk(0), xp, yp)
                    subDecision(1, rndk(1), xp, yp)
                    subDecision(1, rndk(2), xp, yp)
                Case Houkou.Left
                    subDecision(2, rndk(0), xp, yp)
                    subDecision(2, rndk(1), xp, yp)
                    subDecision(2, rndk(2), xp, yp)
                Case Houkou.Right
                    subDecision(3, rndk(0), xp, yp)
                    subDecision(3, rndk(1), xp, yp)
                    subDecision(3, rndk(2), xp, yp)
            End Select
        End If
    End Sub

    Private Sub subDecision(ByVal n1 As Integer, ByVal n2 As Integer, ByVal sxp As Integer, ByVal syp As Integer)
        If flag = True Then
            Dim substa As CellStatus = statuses(n1, n2)
            Dim subhou As Houkou = houkous(n1, n2)

            UnyoNum(substa) += 1
            Joutai(sxp, syp) = substa
            Decision(subhou, sxp + plusX(n1, n2), syp + plusY(n1, n2))
            Joutai(sxp, syp) = CellStatus.Nothing
            UnyoNum(substa) -= 1
        End If
    End Sub

    Private Function RandomN(ByVal minN As Integer, ByVal maxN As Integer) As Integer
        Randomize()
        RandomN = Fix(Rnd() * (maxN - minN + 1)) + minN
    End Function

    Public Sub ShowMaked()
        Dim kx, ky As Integer

        For ky = 0 To 3
            For kx = 0 To 3
                MyGrid.Cells(kx, ky).Status = Joutai(kx, ky)
            Next
        Next
    End Sub

    Public Function CheckClear() As Boolean
        Dim kx, ky As Integer

        For ky = 0 To 3
            For kx = 0 To 3
                MyGrid.Cells(kx, ky).Through = False
                MyGrid.Cells(kx, ky).IamHead = False
            Next
        Next
        CheckClear = CanAdvance(0, 0, Houkou.Up, 0)
    End Function

    Private Function CanAdvance(ByVal xp As Integer, ByVal yp As Integer, ByVal h As Houkou, ByVal counter As Integer)
        counter += 1
        If xp < 0 Or xp > 3 Or yp < 0 Or yp > 3 Then
            If xp = -1 Then
                MyGrid.Cells(0, yp).IamHead = True
                MyGrid.Cells(0, yp).HeadPos = Houkou.Left
            ElseIf xp = 4 Then
                MyGrid.Cells(3, yp).IamHead = True
                MyGrid.Cells(3, yp).HeadPos = Houkou.Right
            ElseIf yp = -1 Then
                MyGrid.Cells(xp, 0).IamHead = True
                MyGrid.Cells(xp, 0).HeadPos = Houkou.Up
            ElseIf yp = 4 Then
                MyGrid.Cells(xp, 3).IamHead = True
                MyGrid.Cells(xp, 3).HeadPos = Houkou.Down
            End If
            If yp = 4 And xp = 3 Then
                If counter = 16 Then
                    CanAdvance = True
                Else
                    CanAdvance = False
                End If
            Else
                CanAdvance = False
            End If
            Exit Function
        End If
        Select Case h
            Case Houkou.Up
                Select Case MyGrid.Cells(xp, yp).Status
                    Case CellStatus.UpDown
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(0, 0, xp, yp, counter)
                    Case CellStatus.LeftUp
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(0, 1, xp, yp, counter)
                    Case CellStatus.RightUp
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(0, 2, xp, yp, counter)
                    Case Else
                        If yp - 1 <> -1 Then
                            MyGrid.Cells(xp, yp - 1).IamHead = True
                            MyGrid.Cells(xp, yp - 1).HeadPos = Houkou.Down
                        End If
                        CanAdvance = False
                End Select
            Case Houkou.Down
                Select Case MyGrid.Cells(xp, yp).Status
                    Case CellStatus.UpDown
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(1, 0, xp, yp, counter)
                    Case CellStatus.LeftDown
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(1, 1, xp, yp, counter)
                    Case CellStatus.RightDown
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(1, 2, xp, yp, counter)
                    Case Else
                        MyGrid.Cells(xp, yp + 1).IamHead = True
                        MyGrid.Cells(xp, yp + 1).HeadPos = Houkou.Up
                        CanAdvance = False
                End Select
            Case Houkou.Left
                Select Case MyGrid.Cells(xp, yp).Status
                    Case CellStatus.LeftRight
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(2, 0, xp, yp, counter)
                    Case CellStatus.LeftUp
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(2, 1, xp, yp, counter)
                    Case CellStatus.LeftDown
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(2, 2, xp, yp, counter)
                    Case Else
                        MyGrid.Cells(xp - 1, yp).IamHead = True
                        MyGrid.Cells(xp - 1, yp).HeadPos = Houkou.Right
                        CanAdvance = False
                End Select
            Case Houkou.Right
                Select Case MyGrid.Cells(xp, yp).Status
                    Case CellStatus.LeftRight
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(3, 0, xp, yp, counter)
                    Case CellStatus.RightUp
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(3, 1, xp, yp, counter)
                    Case CellStatus.RightDown
                        MyGrid.Cells(xp, yp).through = True
                        CanAdvance = SubCanAdvance(3, 2, xp, yp, counter)
                    Case Else
                        MyGrid.Cells(xp + 1, yp).IamHead = True
                        MyGrid.Cells(xp + 1, yp).HeadPos = Houkou.Left
                        CanAdvance = False
                End Select
        End Select
    End Function

    Private Function SubCanAdvance(ByVal n1 As Integer, ByVal n2 As Integer, ByVal sxp As Integer, ByVal syp As Integer, ByVal sc As Integer) As Boolean
        SubCanAdvance = CanAdvance(sxp + plusX(n1, n2), syp + plusY(n1, n2), houkous(n1, n2), sc)
    End Function
End Class
